
#define VERSION "190408"
// * Used RAM (bytes): 319 (8%)  Free RAM (bytes): 3556 (92%)
// * Used ROM (bytes): 2421 (4%)  Free ROM (bytes): 63115 (96%)
// * Project Linked Successfully Anneau_60leds_18F26K22.mcppi


/*
Attention Ordre VERT,Rouge,Bleu  et non RGB
// SPI Hardware
// trop rapide avec FOSC=16MHzx4  et SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4,...);
// trop lent avec 8MHzx4
//..presque OK avec SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV16,...
// utilise


 MCU:             PIC18F26K22
 Oscillator Interne : FOSC=642MHz
 Breadboard
 Ext. modules:    Addressable RGB Anneau 60 leds WS2801-  diam=170mm
 SW:              mikroC PRO for PIC version 7.3

  out

HARDWARE :
     WS2801 Wiring
     - Fil Rouge   +5V
     - Fil Blanc  0V  / Gnd MCU
     - connector fil vert <---- SPI RC5 DOut

     
  MCU
RC0 --------> SQA synchro
SPI1      SDO      RC5   pin 24   ------- fil rouge connector WS2801
UART1 TX  sur RC6        pin 25
UART1 RX  sur RC7        pin 26
     
     
PIC18F26k22_FOSC_interne_16x4-64MHZ.cfgsch
 
CONFIG1H : $300001 : 0x0038
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x00BF
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040



 */

#define DIRECTORY  "C:\\_MikroC\\_MesProjets_MikroC\\_18F46K22_Led_Strip32"
#define PROJECT "Anneau_60leds_18F26K22.mcppi"
#define SOURCE "Anneau_60_leds_RGB_Bit_bang_Hardw_Test_190408.c"

#define PROCESSOR "18F26K22"
#define POWER_SUPPLY 5V

#define FOSC_INTERNE
#define FOSC 64.0  // MHz
#define BAUD 19200  // UART1
#define Langage  Mikroc V 7.30
#define With_UART1

#include "built_in.h"     // for  Hi  Lo ..etc


#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space


//#define UN  192 // 0b11000000   0b11110000
#define UN  224 // 0b11000000   0b11110000
#define ZERO 252 // 0b11111100


#define NB_LEDS 60

//--------- LED definitions ---------
sbit LD1 at LATA.B4;
sbit LD1_Direction at TRISA.B4;
sbit DOut at LATC.B5;               //DATA  OUT PIN
sbit SQA at LATC.B0;               //synchro datalogger OUT PIN

sbit DOut_Direction  at TRISC.B5;   //DATA DIRECTION Output
sbit SQA_Direction  at TRISC.B0;   // //synchro datalogger DIRECTION Output
sbit SoftSpi_CLK at LATC.B3;
sbit Clock at LATC.B3;               //CLOCK OUT PIN

const code char mesg0[]=" Mikroc 7.30 "PROCESSOR" \n\r";
const code char mesg1[]=" Directory : "DIRECTORY" \n\r";
const code char mesg2[]=" Projet : "PROJECT"\r\n";
const code char mesg3[]=" Source : "SOURCE"_"VERSION".c \r\n";
const code char mesg4[]=" Anneau 60 leds RGB WS2812\n\r";
const code char mesg5[]=" Saisir un nouveau Msg avec le terminal via Msg=\r\n";
const code char mesg6[]=" Raccordement strip : Rouge +5V ,Vert=DI  , Blanc=Gnd\r\n";
const code char mesg7[]=" Cde direct Bit Bang Hardware \r\n";
const code char mesg8[]=" Usage de ASM dans C \r\n";
const code char mesg9[]="  ";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9};

#define MAXLEN1 128
volatile unsigned char buffer1[MAXLEN1];
volatile int Flag_Buffer1;
volatile  unsigned char c1;
volatile unsigned int i1;
volatile int Index1;
volatile unsigned int CptErr;


static int Flag_Timer1;
static unsigned int Cpt1;
static unsigned int Max_Timer1;




int i,j,k,l,m,n;
unsigned  char TEXTE[80]; // pour teste quelconque
unsigned char * txt;
unsigned char *p;
unsigned long L1,L2 ;

char CRam1[32];   // for flot2asccii use
unsigned char cnt;
unsigned int LEDs=32;
unsigned char Rouge,Vert,Bleu,Mode;
unsigned char MCOM2;
int Cspeed=255;

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Init_Timer1 (void);  //  timer 100mS * Max_timer1
void Arme_Timer1(void);   //
void Init_Timer0 (void);  //  counter in RA4 input
void strConstRamCpy(unsigned char *dest, const code char *source);
void UART1_Write_CText(const char *txt);
void RAZ_UART1(void);
unsigned char *Float2Ascii (float x, unsigned char *chaine,char precision) ;
void CRLF1(void)  ;


void Interrupt_High() iv 0x0008 ics ICS_AUTO
{
 if ( (RCIE_bit) && ( RCIF_bit))
   {
   // traitement separe des erreurs de COM
      c1 = RCREG;
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
     if ((c1==CR) || (i1 > MAXLEN1-2))
      {
      Flag_Buffer1=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        if (i1 > MAXLEN1-2)  Flag_Buffer1=2;
        buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
   }
     // -----  timer 1  ----------------
   if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1++;
     // pour debug only
     // TXREG1='#';
     if (Cpt1 >=Max_Timer1)   // x100 ms
       {
        TMR1IE_bit=0; // stop comptage  timer1
        TMR1ON_bit=0;
        Cpt1=0;
        Flag_Timer1=1;
        TMR1ON_bit=0;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
 }


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

void Init_Timer2(void)
{
//Timer2    FOSC=64Mhz
//Prescaler 1:1; Postscaler 1:1; TMR2 Preload = 9; Actual Interrupt Time : 625 ns
  T2CON         = 0x04;
  TMR2IE_bit         = 1;
  PR2                 = 9;
  INTCON         = 0x00;
}




 void Init_Hardware()
{
  PORTA = 0;
  ANSELA=0;
  //ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  TRISA = 0xFF;   // RA4=sortie
  LD1_Direction = 0; //OUTPUT   LED1
  CCP5CON=0;

  PORTB = 0xFF;
  TRISB = 0xFF;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0xFF;    //
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1

  // pour SPI soft
  //SoftSpi_SDI_Direction =1;//at TRISC.B4;
  //SoftSpi_SDO_Direction =0; //at TRISC.B5;
  //SoftSpi_CLK_Direction =0; //at TRISC.B3;

  // pour SPI bit Bang
  //Clock_Direction = 0; //OUTPUT   CLOCK OUT
  DOut_Direction = 0; //OUTPUT   DATA OUT
  DOut=0;
  SQA_Direction =0;
  SQA=0;
  //Clock=0;
  DOut=0;

  LD1=1;
  Delay_ms(1000);
  LD1=0;
  Delay_ms(1000);
  LD1=1;
 }



void RAZ_UART1()
{
    for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
    i1=0;
    Index1=0;
    c1=RC1REG;
    c1=0;
    Flag_Buffer1 =0;
    RC1IE_bit = 1;
}

void Arme_Timer1(void)
{
   // 100mS * Max_Timer1
  TMR1IF_bit         = 0;
  TMR1H         = 0x0B;
  TMR1L         = 0xDC;
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IE_bit= 1;
  }


void Init_Timer1(void)
 {
//FOSC=16Mhz  Prescaler 1:8; TMR1 Preload = 3035; Actual Interrupt Time : 125 ms
  T1CON         = 0x00;
  TMR1CS1_bit=0; // FOSC/4
  TMR1CS0_bit=0;
  T1RD16_bit=1;
  T1CKPS1_bit=1;  //Prescaler 1:8
  T1CKPS0_bit=1;
  TMR1H  = 0x0B;
  TMR1L  = 0xDC;
   TMR1IF_bit  = 0;
  #ifdef Timer1_LOW
  TMR1IP_bit=0;   // low level interrupt
  #else
  TMR1IP_bit=1;   // low level interrupt
  #endif
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=0;
  TMR1IE_bit =0;
}

 unsigned char LATCx absolute 0x0F8B;

 void ONES ()
 {
  _asm   {
      BSF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      BCF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      }
   }
  void ZEROS ()
  {
    _asm   {
      BSF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      BCF _LATCx,5;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      }
   }
 
 void RAZ_Anneau_60_Leds()
 { int j;
   DOut=1;
   Delay_ms(1);
   DOut=0;
   Delay_us(100);
   for (j=0;j<1440;j++)
   {
     ZEROS();
   }
    DOut=1;
   Delay_ms(1);
   DOut=0;
   Delay_us(100);
  }
//======================================================================


void main()
 {
 #ifdef FOSC_INTERNE
 // OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz
 // OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz
 // OSCTUNE.PLLEN=0
  OSCTUNE=0;
  //OSCTUNE=OSCTUNE | 0x3F; //0b111111;  // maxima =>frequence  +3%
  //OSCTUNE=OSCTUNE | 0x1F; //0b011111;  // maxima => frequence -3%
  //OSCCON = 0b01100000  ; //0x62 ;     //Oscillateur  8Mhz x 4 =32
  OSCCON = 0b01110000  ; //0x72 ;     //Oscillateur  16Mhz  x 4
  OSCTUNE.PLLEN=1;
  OSCCON2=0;
  while (OSCCON.HFIOFS==0); // wait stable oscillator
  #else
  // Q=20Mhz
  #endif

   Delay_ms(1000);

   Init_Hardware();    // Initialize MCU and peripherals
   Clock=0;
   DOut=0;
   SQA=0;
   
   Max_Timer1=8;
   UART1_Init(19200);
   Delay_ms(100);
   UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
   Delay_ms(500);

   txt=&TEXTE[0];
   CRLF1();
    // presentation sur UART1
   for(i=0;i<9;i++)
   {
       UART1_Write_CText(Messages[i]);
   }
   Delay_ms(2000);
   CRLF1();
   
   #ifdef Phase_Test
   UART1_Write_CText(" Phase de Test avec SQA analyser : la 1ere led doit s'allumer en Vert \r\n" );
   SQA=1;
      ZEROS();ZEROS();ZEROS();ZEROS();ONES();ONES();ONES();ONES(); // VERT
    SQA=0;
      ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS()   ;  // ROUGE
     SQA=1;
       ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS()   ;  // BLEU
     SQA=0;
    while(1);
   #endif

   Init_Timer2();  //actual Interrupt Time : 625 ns
  

    UART1_Write_CText(" Reset Index pointeur Led \r\n" );
    DOut=1;
    Delay_us(100);
    DOut=0;
    Delay_us(100);

    UART1_Write_CText(" Parcours des 60 leds  \r\n" );
    do
    {
      DOut=0;
      Delay_us(100);
      j=0;
      m=0;
     do
     {

       for (k=0;k<j;k++)
       {
         switch (m)
         {
         case 0 :
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            // ROUGE
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS(); ZEROS(); ONES();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            break;
        case 1:
            //VERT
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS(); ZEROS();ZEROS();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            break;
         case 2:
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS(); ZEROS();ZEROS();
            //BLEU
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES();
            break;
          default:
          // BLANC
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS(); ZEROS();ONES();
            ZEROS();ZEROS(); ZEROS();ZEROS();ZEROS();ZEROS();ZEROS();ONES();
            break ;
          }
          if (m>4) m=0;
       }
       m++;
      Delay_1sec();
      RAZ_Anneau_60_Leds();
      UART1_Write_CText(" time is ");
      WordToStr(j,CRam1);
      UART1_Write_Text(CRam1);
      CRLF1();
      j++;
     } while(j<NB_LEDS);
     
      UART1_Write_CText(" fin \r\n");
      Delay_1sec();  
      Delay_1sec();
      //  RAZ_UART1();  // init Interrupt UART1
      //     Init_Timer1();
      //   Arme_Timer1();
      //   while((Flag_Timer1==0) && ( Flag_Buffer1==0));
    }  while (1);

  }
  
  
  /*

 Mikroc 7.30 18F26K22
 Directory : C:\_MikroC\_MesProjets_MikroC\_18F46K22_Led_Strip32
 Projet : Anneau_60leds_18F26K22.mcppi
 Source : Anneau_60_leds_RGB_Bit_bang_Hardw_Test_190408.c_190408.c
 Anneau 60 leds RGB WS2812
 Saisir un nouveau Msg avec le terminal via Msg=
 Raccordement strip : Rouge +5V ,Vert=DI  , Blanc=Gnd
 Cde direct Bit Bang Hardware
 Usage de ASM dans C

 Reset Index pointeur Led
 Parcours des 60 leds
 time is     0
 time is     1
 time is     2
 
 la couleur change  chaque pas
 VERT,ROUGE,BLEU,BLANC
 
 time is    55
 time is    56
 time is    57
 time is    58
 time is    59
 fin
 time is     0
 time is     1
 time is     2
 time is     3
  
 =======================


0 1 mikroCPIC1618.exe -MSF -DBG -pP18F26K22 -RA -C -DL -O11111114 -fo64 -EH"^C
C:\_MikroC\_MesProjets_MikroC\_Anneau_60leds_RGB\Anneau_60leds_cde_bit_bang_18F26K22_eeprom.ihex" -N"^C
C:\_MikroC\_MesProjets_MikroC\_Anneau_60leds_RGB\Anneau_60leds_cde_bit_bang_18F26K22.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\_Anneau_60leds_RGB\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -IP"^C
C:\_MikroC\_MesProjets_MikroC\_Anneau_60leds_RGB\" "Anneau_60_leds_RGB_Bit_bang_Hardw_Test_190408.c" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CType.mcl" "
_Lib_CString.mcl" "
_Lib_CStdlib.mcl" "
_Lib_Conversions.mcl" "
_Lib_SoftSPI.mcl" "
_Lib_SPI_c345b123.mcl" "
_Lib_UART_c67b67.mcl" "
_Lib_LcdConsts.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started P18F26K22.c
2623 123 Compiled Successfully P18F26K22.c
0 122 Compilation Started
_Lib_Delays.c
172 123 Compiled Successfully
_Lib_Delays.c
0 122 Compilation Started Anneau_60_leds_RGB_Bit_bang_Hardw_Test_190408.c
0 1004 interrupt handler (Interrupt_High at 0x0008) Anneau_60_leds_RGB_Bit_bang_Hardw_Test_190408.c
520 123 Compiled Successfully Anneau_60_leds_RGB_Bit_bang_Hardw_Test_190408.c
0 127 All files Compiled in 203 ms
0 1144 Used RAM (bytes): 319 (8%)  Free RAM (bytes): 3556 (92%) Used RAM (bytes): 319 (8%)  Free RAM (bytes): 3556 (92%)
0 1144 Used ROM (bytes): 2455 (4%)  Free ROM (bytes): 63081 (96%) Used ROM (bytes): 2455 (4%)  Free ROM (bytes): 63081 (96%)
0 125 Project Linked Successfully Anneau_60leds_cde_bit_bang_18F26K22.mcppi
0 128 Linked in 125 ms
0 129 Project 'Anneau_60leds_cde_bit_bang_18F26K22.mcppi' completed: 859 ms
0 103 Finished successfully: 08 avr. 2019, 17:10:17 Anneau_60leds_cde_bit_bang_18F26K22.mcppi

*/